ADAELA (Event Analytics Administration)

#### Search Results

Search

# ADAELA (Event Analytics Administration)

This document describes the utility "ADAELA".

The following topics are covered:

- Functional Overview

- Procedure Flow

- Checkpoints

- Control Parameters

## Functional Overview

The administration utility ADAELA configures the Event Analytics add-on. It does not require the Adabas nucleus to be active, but if changes are made to the configuration, the nucleus must be restarted in order to make them active.

More than one event type can be added or removed during a single run of the utility. It is also possible to both add and remove event types during a single run. If more than one `add_eventtype,…` and/or `remove=eventtype,…` statement is issued, each statement must be finished with the keyword `END_OF_EVENTTYPE`.

Note
If there is already a configuration present, it will be overwritten.

This utility is a multi-function utility. For more information about single- and multi-function utilities, see Adabas Basics, Using Utilities.

## Procedure Flow

Data Set | Environment Variable/ Logical Name | Storage Medium | Additional Information
--- | --- | --- | ---
Database configuration |  | DBnnn.ini |
Event types store |  | eventtypes.txt |
Control statements | stdin |  | see section Control Parameters
ADAELA messages | stdout |  | Messages and Codes

## Checkpoints

The utility writes no checkpoints.

## Control Parameters

The following control parameters are available:

    ADD_SERVER
               [ ,server_keywords]
    ADD_NUCELG
               [ ,nucelg_keywords]
    ADD_EVENTTYPE
               [ ,eventtype_keywords]
    ADD_FILTER
               [ ,filter_keywords]

    M   DBID = number

        DISABLE

        DISPLAY = CONFIGURATION | EVENTTYPES

        ENABLE

        REMOVE = SERVER | NUCELG | EVENTTYPE, NAME=string | FILTER

### ADD_SERVER

    ADD_SERVER
    D            [,HOST=string]
    D            [,PORT=number]
    D            [,RECONNECT_TIMEOUT=number]
    D            [,RETRY=number]
    D            [,ON_ERROR=keyword]

This parameter adds the Analytics Server configuration to the DBnnn.INI file. It is not possible to use the Analytics Server in parallel to writing events into a file (see NUCELG). If there is already a configuration for the NUCELG file present, it will be deleted.

#### HOST=string

The hostname where the Analytics Server is running. The default is localhost, which assumes that the server will run on the same host as the Adabas nucleus for the best performance.

#### PORT=number

The TCP/IP listen port number of the Analytics Server. The default value is 6521. The port number must match the port number configured in the Analytics Server.

#### RECONNECT_TIMEOUT=number

If the connection between the Adabas nucleus and the Analytics Server is lost, this parameter specifies the time (in seconds) that the Adabas nucleus waits between reconnect attempts to the Analytics Server. The default is 1.

Note
Reconnect attempts are time consuming and have a negative impact on the Adabas performance.

#### RETRY=number

If the connection between the Adabas nucleus and the Analytics Server is lost, this parameter specifies the number of reconnect attempts. The default is 0, which means "try continuously".

Note
If the maximum number of attempts is not 0, and if the maximum number of reconnect attempts is reached without reconnecting successfully, event logging will be deactivated.

#### ON_ERROR=keyword

This parameter defines the behavior of the Adabas nucleus in case an error occurs with the Analytics Server. The default is IGNORE. ‘keyword’ can take one of the following values:

Keyword | Meaning
--- | ---
ABORT | The Adabas nucleus will abort on any error condition with the Analytics Server.
IGNORE | The Adabas nucleus will attempt to reconnect to the Analytics Server.

### ADD_NUCELG

    ADD_NUCELG
    D            [,TIME_SWITCH=number]
    D            [,EVENT_SWITCH=number]
    D            [,ELGFILE=path]

This parameter adds the configuration for writing events to a file. It is not possible to use the Analytics Server in parallel to writing events into a file. If there is already a configuration for the Analytics Server present, it will be deleted.

#### TIME_SWITCH=number

The time (in seconds) that elapses before starting a new log file. The default value is 0, which means that the log file is never switched after a given time.

#### EVENT_SWITCH=number

The number of events that have to occur before starting a new log file. The default value is 0, which means that the log file is never switched after a given number of events.

#### ELGFILE=path

The fully-qualified path name for the log file. The default is $ADADATADIR/dbnnn/NUCELG or %ADADATADIR%\dbnnn\NUCELG. A numbering suffix will be added automatically.

### ADD_EVENTTYPE

    ADD_EVENTTYPE ,NAME=string
                    ,AREA=keyword
                    ,FIELDS=(keyword [,keyword] …)
    D              [,FILE=path]
    D              [,END_OF_EVENTTYPE]

This parameter adds an event-type definition to the event types file.

#### NAME=string

The name of the event type.

#### FILE=PATH

The fully-qualified path name to the file which stores the event types.

#### AREA=keyword

The area where the event will be created. keyword can take one of the following values:

Keyword | Meaning
--- | ---
POST_COMMAND | The event is based on the Adabas Control Block. After a regular Adabas command has been processed, an event that depends on the command code will be sent. The area defines also which fields are available for the event.

#### FIELDS = (keyword [,keyword] …)

A list of the fields for the event type. The following fields are available:

Keyword | Area | Type, Length | Meaning
--- | --- | --- | ---
event_timestamp | POST_COMMAND | Integer, 8 | Timestamp when the event was generated
Dbid | POST_COMMAND | Integer, 4 | Database ID
file_number | POST_COMMAND | Integer, 4 | Adabas file number
command_code | POST_COMMAND | String, 2 | Adabas command code
response_code | POST_COMMAND | Integer,4 | Nucleus response code
Pid | POST_COMMAND | Integer, 8 | Process ID
Isn | POST_COMMAND | Integer, 8 | ISN
hostname | POST_COMMAND | String, 8 | Host name
user_id | POST_COMMAND | String, 8 | User ID
Tsid | POST_COMMAND | Binary, 8 | Unique identifier
natapplication | POST_COMMAND | String, 8 | Natural application name
natprogram | POST_COMMAND | String, 8 | Natural program name
natlevel | POST_COMMAND | Integer, 4 | Natural call level
natcount | POST_COMMAND | Integer, 8 | Number of Adabas calls since last IO
natexec | POST_COMMAND | Integer, 8 | Number of times a Natural object has been executed
natuser | POST_COMMAND | String, 8 | Natural user ID
natstatement | POST_COMMAND | String, 4 | Natural statement number
Natlib | POST_COMMAND | String, 8 | Natural library name
natrpcclientuid | POST_COMMAND | String, 8 | Natural RPC client user ID
natrpcid | POST_COMMAND | String, 16 | Natural RPC ID
natrpcconvid | POST_COMMAND | String, 16 | Natural RPC conversation ID
natsecgroup | POST_COMMAND | String, 8 | Natural security group
additions1 | POST_COMMAND | Binary, 8 | Additions 1 field
duration | POST_COMMAND | Integer, 4 | Command duration in microseconds
command_opt1 | POST_COMMAND | Character, 2 | Command option 1 field
command_opt2 | POST_COMMAND | Character, 2 | Command option 2 field
asso_io_count | POST_COMMAND | Integer, 8 | Number of the I/O read or writes to the ASSO container
data_io_count | POST_COMMAND | Integer, 8 | Number of the I/O read or writes to the DATA container
work_io_count | POST_COMMAND | Integer, 8 | Number of the I/O read or writes to the WORK container
compressed_rec_lng | POST_COMMAND | Integer, 4 | Compressed record length returned by READ or a FIND command stored in the database
decompressed_rec_lng | POST_COMMAND | Integer, 4 | Decompressed record length stored in the database after command completes
descriptor_count | POST_COMMAND | Integer, 4 | Counter for updated descriptor per Adabas call stored in database
cq_wait_duration | POST_COMMAND | Integer, 8 | Duration in microseconds for a command in command queue before dispatching into an Adabas thread
isn_lower_limit | POST_COMMAND | Integer, 4 | Adabas ISN Lower Limit
isn_quantity | POST_COMMAND | Integer, 4 | Adabas ISN Quantity
command_opt3 | POST_COMMAND | Character, 2 | Contains the value of command option 3 of the processed call
command_opt4 | POST_COMMAND | Character, 2 | Contains the value of command option 4 of the processed call
command_opt5 | POST_COMMAND | Character, 2 | Contains the value of command option 5 of the processed call
command_opt6 | POST_COMMAND | Character, 2 | Contains the value of command option 6 of the processed call
command_opt7 | POST_COMMAND | Character, 2 | Contains the value of command option 7 of the processed call
command_opt8 | POST_COMMAND | Character, 2 | Contains the value of command option 8 of the processed call
additions2 | POST_COMMAND | Binary, 4 | Contains the additions2 field of the issued call
additions3 | POST_COMMAND | Binary, 8 | Contains the additions3 field of the issued call
additions4 | POST_COMMAND | Binary, 8 | Contains the additions4 field of the issued call
additions5 | POST_COMMAND | Binary, 8 | Contains the additions5 field of the issued call
additions6 | POST_COMMAND | Binary, 8 | Contains the additions6 field of the issued call
Error_offset | POST_COMMAND | Integer, 8 | Error offset in buffer
Error_field | POST_COMMAND | String, 2 | Error character field

#### END_OF_EVENTTYPE

The keyword END_OF_EVENTTYPE must be specified if more than one event type is added, or if an event type is added and one or more event types are removed.

### ADD_FILTER

    ADD_FILTER
    D            [ ,filter_keywords]

This parameter adds filter keywords to a file.

### DBID

    DBID = number

This parameter selects the database to be used.

### DISABLE

    DISABLE

This parameter disables the event logging feature.

### DISPLAY

    DISPLAY = CONFIGURATION | EVENTTYPES

This parameter display information about the event logging. The following keywords can be specified:

Keyword | Meaning
--- | ---
CONFIGURATION | Displays the configuration of the event logging. The information is taken from the DBnnn.INI file.
EVENTTYPES | Displays all configured event types.

### ENABLE

    ENABLE

This parameter enables the event logging feature.

### REMOVE

    REMOVE = SERVER | NUCELG | EVENTTYPE, NAME=string | FILTER

#### REMOVE = SERVER

This parameter removes the server configuration. The section TARGET_SERVER will be removed from the DBnnn.INI file.

#### REMOVE = NUCELG

This parameter removes the NUCELG configuration.

#### REMOVE = EVENTTYPE, NAME=string [,END_OF_EVENTTYPE]

This parameter removes an event type with the specified name from the event types file.

The keyword END_OF_EVENTTYPE must be specified if more than one event type is removed, or if an event type is removed and one or more event types are added.

### On this page

- Functional Overview
- Procedure Flow
- Checkpoints
- Control Parameters